<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.14" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="cyhal__lptimer_8c" kind="file" language="C++">
    <compoundname>cyhal_lptimer.c</compoundname>
    <includes local="yes">cmsis_compiler.h</includes>
    <includes local="yes">cy_mcwdt.h</includes>
    <includes local="yes">cy_syslib.h</includes>
    <includes local="yes">cy_sysint.h</includes>
    <includes local="yes" refid="cyhal__lptimer_8h">cyhal_lptimer.h</includes>
    <includes local="yes" refid="cyhal__hwmgr_8h">cyhal_hwmgr.h</includes>
    <includes local="yes" refid="cyhal__system__impl_8h">cyhal_system_impl.h</includes>
    <includes local="yes" refid="cyhal__utils_8h">cyhal_utils.h</includes>
    <incdepgraph>
      <node id="168">
        <label>cy_mcwdt.h</label>
      </node>
      <node id="166">
        <label>cyhal_lptimer.c</label>
        <link refid="cyhal__lptimer_8c" />
        <childnode refid="167" relation="include">
        </childnode>
        <childnode refid="168" relation="include">
        </childnode>
        <childnode refid="169" relation="include">
        </childnode>
        <childnode refid="170" relation="include">
        </childnode>
      </node>
      <node id="170">
        <label>cy_sysint.h</label>
      </node>
      <node id="169">
        <label>cy_syslib.h</label>
      </node>
      <node id="167">
        <label>cmsis_compiler.h</label>
      </node>
    </incdepgraph>
      <sectiondef kind="define">
      <memberdef id="cyhal__lptimer_8c_1a6cefb70cb0b499c8e281364b2cfe589e" kind="define" prot="public" static="no">
        <name>_CYHAL_LPTIMER_MCWDT_CTRL</name>
        <initializer>(CY_MCWDT_CTR0 | CY_MCWDT_CTR1 | CY_MCWDT_CTR2)</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_lptimer.c" bodystart="63" column="9" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_lptimer.c" line="63" />
      </memberdef>
      <memberdef id="cyhal__lptimer_8c_1a4c7c8b01c662d271cc904a9b3d2f0f7c" kind="define" prot="public" static="no">
        <name>_CYHAL_LPTIMER_MIN_DELAY</name>
        <initializer>(3U) /* minimum amount of lfclk cycles of that LPTIMER can delay for. */</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_lptimer.c" bodystart="65" column="9" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_lptimer.c" line="65" />
      </memberdef>
      <memberdef id="cyhal__lptimer_8c_1a10614eb5b8356d9610856e482b246234" kind="define" prot="public" static="no">
        <name>_CYHAL_LPTIMER_MAX_DELAY_TICKS</name>
        <initializer>(0xfff0ffffUL) /* ~36hours, Not set to 0xffffffff to avoid C0 and C1 both overflowing */</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_lptimer.c" bodystart="66" column="9" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_lptimer.c" line="66" />
      </memberdef>
      <memberdef id="cyhal__lptimer_8c_1ad946e47de765d8565cc59a770dc19f26" kind="define" prot="public" static="no">
        <name>_CYHAL_LPTIMER_MAX_COUNTER_VAL</name>
        <initializer>(0xffffffffUL) /* Maximum value of the counter before it rolls over */</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_lptimer.c" bodystart="67" column="9" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_lptimer.c" line="67" />
      </memberdef>
      <memberdef id="cyhal__lptimer_8c_1ac42aee5f79cfe256047e963192068b6c" kind="define" prot="public" static="no">
        <name>_CYHAL_LPTIMER_DEFAULT_PRIORITY</name>
        <initializer>(3U)</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_lptimer.c" bodystart="69" column="9" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_lptimer.c" line="69" />
      </memberdef>
      <memberdef id="cyhal__lptimer_8c_1a1d628f625d796a76083ddbda199e0110" kind="define" prot="public" static="no">
        <name>_CYHAL_LPTIMER_CLK_FREQ_HZ</name>
        <initializer>(32768U)</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_lptimer.c" bodystart="72" column="9" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_lptimer.c" line="72" />
      </memberdef>
      </sectiondef>
      <sectiondef kind="var">
      <memberdef id="cyhal__lptimer_8c_1a4cf395eecd9ff5824b5ec84a73c5521f" kind="variable" mutable="no" prot="public" static="yes">
        <type>MCWDT_STRUCT_Type *const</type>
        <definition>MCWDT_STRUCT_Type* const _CYHAL_LPTIMER_BASE_ADDRESSES[]</definition>
        <argsstring>[]</argsstring>
        <name>_CYHAL_LPTIMER_BASE_ADDRESSES</name>
        <initializer>= {

    MCWDT_STRUCT0,







}</initializer>
        <briefdescription>
<para>group_hal_impl_lptimer </para>        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_lptimer.c" bodystart="51" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_lptimer.c" line="51" />
      </memberdef>
      <memberdef id="cyhal__lptimer_8c_1ad3b3d1126570d4a88569f892b8295ccf" kind="variable" mutable="no" prot="public" static="yes">
        <type>const uint16_t</type>
        <definition>const uint16_t _CYHAL_LPTIMER_RESET_TIME_US</definition>
        <argsstring />
        <name>_CYHAL_LPTIMER_RESET_TIME_US</name>
        <initializer>= 62</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_lptimer.c" bodystart="74" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_lptimer.c" line="74" />
      </memberdef>
      <memberdef id="cyhal__lptimer_8c_1a88d05909dd60d71170d2281c7c3ea01b" kind="variable" mutable="no" prot="public" static="yes">
        <type>const uint16_t</type>
        <definition>const uint16_t _CYHAL_LPTIMER_SETMATCH_NOWAIT_TIME_US</definition>
        <argsstring />
        <name>_CYHAL_LPTIMER_SETMATCH_NOWAIT_TIME_US</name>
        <initializer>= 0</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_lptimer.c" bodystart="75" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_lptimer.c" line="75" />
      </memberdef>
      <memberdef id="cyhal__lptimer_8c_1a422fe5fb90db53c923f98fe06fa1020e" kind="variable" mutable="no" prot="public" static="yes">
        <type><ref kindref="compound" refid="structcyhal__lptimer__t">cyhal_lptimer_t</ref> *</type>
        <definition>cyhal_lptimer_t* _cyhal_lptimer_config_structs[1]</definition>
        <argsstring>[1]</argsstring>
        <name>_cyhal_lptimer_config_structs</name>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_lptimer.c" bodystart="77" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_lptimer.c" line="77" />
      </memberdef>
      </sectiondef>
      <sectiondef kind="func">
      <memberdef const="no" explicit="no" id="cyhal__lptimer_8c_1a5ff24bd98706539b7be41784eff9ff01" inline="no" kind="function" prot="public" static="yes" virt="non-virtual">
        <type>void</type>
        <definition>static void _cyhal_lptimer_irq_handler</definition>
        <argsstring>(void)</argsstring>
        <name>_cyhal_lptimer_irq_handler</name>
        <param>
          <type>void</type>
        </param>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="97" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_lptimer.c" bodystart="79" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_lptimer.c" line="79" />
      </memberdef>
      <memberdef const="no" explicit="no" id="cyhal__lptimer_8c_1a08b0c484353774b9b3aec6b98421dba1" inline="no" kind="function" prot="public" static="yes" virt="non-virtual">
        <type>uint32_t</type>
        <definition>static uint32_t _cyhal_lptimer_set_delay_common</definition>
        <argsstring>(cyhal_lptimer_t *obj, uint32_t delay)</argsstring>
        <name>_cyhal_lptimer_set_delay_common</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__lptimer__t">cyhal_lptimer_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type>uint32_t</type>
          <declname>delay</declname>
        </param>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
<para>16 bit C0/C1 are cascaded to generated a 32 bit counter. Counter0 continues counting after reaching its match value Interrupt is generated on Counter1 match.</para><para>Supposed T=C0=C1=0, and we need to trigger an interrupt at T=0x28000. We set C0_match to 0x8000 and C1 match to 1. At T = 0x8000, C0_value matches C0_match so C1 get incremented. C1/C0=0x18000. At T = 0x18000, C0_value matches C0_match again so C1 get incremented from 1 to 2. When C1 get incremented from 1 to 2 theinterrupt is generated. At T = 0x18000, C1/C0 = 0x28000.</para>        </inbodydescription>
        <location bodyend="159" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_lptimer.c" bodystart="99" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_lptimer.c" line="99" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__lptimer_1gad5438541af765572369ee96588bd4ee5" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_lptimer_init</definition>
        <argsstring>(cyhal_lptimer_t *obj)</argsstring>
        <name>cyhal_lptimer_init</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__lptimer__t">cyhal_lptimer_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <briefdescription>
<para>Initialize the LPTimer. </para>        </briefdescription>
        <detaileddescription>
<para>Initialize or re-initialize the LPTimer. This resets all the clocking and prescaler registers, along with disabling the compare interrupt. Refer to the BSP for the clock source for the LPTimer.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="out">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>Pointer to an LPTimer object. The caller must allocate the memory for this object but the init function will initialize its contents. </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the init request. On success it returns <ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref>. </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="214" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_lptimer.c" bodystart="161" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_lptimer.c" line="161" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__lptimer_1ga0cbaebaddaa47faf71a69d46c65f7917" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void cyhal_lptimer_free</definition>
        <argsstring>(cyhal_lptimer_t *obj)</argsstring>
        <name>cyhal_lptimer_free</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__lptimer__t">cyhal_lptimer_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <briefdescription>
<para>Deinitialize the LPTimer. </para>        </briefdescription>
        <detaileddescription>
<para>Powers down the LPTimer. After calling this function no other LPTimer functions should be called except <ref kindref="member" refid="group__group__hal__lptimer_1gad5438541af765572369ee96588bd4ee5">cyhal_lptimer_init()</ref>. Calling any function other than init after freeing is undefined.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="inout">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The LPTimer object </para></parameterdescription>
</parameteritem>
</parameterlist>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="232" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_lptimer.c" bodystart="216" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_lptimer.c" line="216" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__lptimer_1ga5ed361c85190707574565009eb325473" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_lptimer_reload</definition>
        <argsstring>(cyhal_lptimer_t *obj)</argsstring>
        <name>cyhal_lptimer_reload</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__lptimer__t">cyhal_lptimer_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <briefdescription>
<para>Reload/Reset the Low-Power timer. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The LPTimer object </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the reload request. On success it returns <ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref>. </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="238" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_lptimer.c" bodystart="234" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_lptimer.c" line="234" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__lptimer_1ga39d049f6f4bdd0bcd4e0be2ab48d3394" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_lptimer_set_match</definition>
        <argsstring>(cyhal_lptimer_t *obj, uint32_t ticks)</argsstring>
        <name>cyhal_lptimer_set_match</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__lptimer__t">cyhal_lptimer_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type>uint32_t</type>
          <declname>value</declname>
          <defname>ticks</defname>
        </param>
        <briefdescription>
<para>Update the match/compare value. </para>        </briefdescription>
        <detaileddescription>
<para>Update the match value of an already configured LPTimer set up to generate an interrupt on match. Note that this function does not reinitialize the counter or the associated peripheral initialization sequence. <verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;This does not reset the counter.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The LPTimer object </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">value</parametername>
</parameternamelist>
<parameterdescription>
<para>The tick value to match</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the set_match request. On success it returns <ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref>. </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="244" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_lptimer.c" bodystart="240" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_lptimer.c" line="240" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__lptimer_1gae91cdc8b63ef191f5a2013df3aaa5d78" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_lptimer_set_delay</definition>
        <argsstring>(cyhal_lptimer_t *obj, uint32_t delay)</argsstring>
        <name>cyhal_lptimer_set_delay</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__lptimer__t">cyhal_lptimer_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type>uint32_t</type>
          <declname>delay</declname>
        </param>
        <briefdescription>
<para>Update the match/compare value. </para>        </briefdescription>
        <detaileddescription>
<para>Update the match value of an already configured LPTimer set up to generate an interrupt on match delay from the current counter value. Note that this function does not reinitialize the counter or the associated peripheral initialization sequence. <verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;This does not reset the counter.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The LPTimer object </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">delay</parametername>
</parameternamelist>
<parameterdescription>
<para>The ticks to wait. The minimum permitted delay value can be queried using <ref kindref="member" refid="group__group__hal__lptimer_1ga35efd806c6a7e0a3c80ef41b0f1e989d">cyhal_lptimer_get_info</ref></para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the set_match request. On success it returns <ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref>. </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="250" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_lptimer.c" bodystart="246" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_lptimer.c" line="246" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__lptimer_1gae759c60b5865a26599353e436518b1d3" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>uint32_t</type>
        <definition>uint32_t cyhal_lptimer_read</definition>
        <argsstring>(const cyhal_lptimer_t *obj)</argsstring>
        <name>cyhal_lptimer_read</name>
        <param>
          <type>const <ref kindref="compound" refid="structcyhal__lptimer__t">cyhal_lptimer_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <briefdescription>
<para>Read the current tick. </para>        </briefdescription>
        <detaileddescription>
<para>If no rollover has occurred, the seconds passed since <ref kindref="member" refid="group__group__hal__lptimer_1gad5438541af765572369ee96588bd4ee5">cyhal_lptimer_init()</ref> or <ref kindref="member" refid="group__group__hal__lptimer_1gae51c0464d3c9ca35707e15afe31ccb54">cyhal_lptimer_set_time()</ref> was called can be found by dividing the ticks returned by this function by the frequency of the source clock (Refer to BSP Settings section in the kit's BSP API Reference Manual for details on the clock source for LPTimer).</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The LPTimer object </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The timer's timer value in ticks </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="255" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_lptimer.c" bodystart="252" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_lptimer.c" line="252" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__lptimer_1gac670fa5380ffd41e548dac6975500b3d" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void cyhal_lptimer_register_callback</definition>
        <argsstring>(cyhal_lptimer_t *obj, cyhal_lptimer_event_callback_t callback, void *callback_arg)</argsstring>
        <name>cyhal_lptimer_register_callback</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__lptimer__t">cyhal_lptimer_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__group__hal__lptimer_1ga09c30c6a9abcbd1a738529102aa9c9b5">cyhal_lptimer_event_callback_t</ref></type>
          <declname>callback</declname>
        </param>
        <param>
          <type>void *</type>
          <declname>callback_arg</declname>
        </param>
        <briefdescription>
<para>Register a LPTimer match event handler. </para>        </briefdescription>
        <detaileddescription>
<para>This function will be called when one of the events enabled by <ref kindref="member" refid="group__group__hal__lptimer_1gaa07d09cfeb275d1343a335f6b4caec9c">cyhal_lptimer_enable_event</ref> occurs.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The LPTimer object </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">callback</parametername>
</parameternamelist>
<parameterdescription>
<para>The callback handler which will be invoked when the interrupt triggers </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">callback_arg</parametername>
</parameternamelist>
<parameterdescription>
<para>Generic argument that will be provided to the handler when called </para></parameterdescription>
</parameteritem>
</parameterlist>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="265" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_lptimer.c" bodystart="257" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_lptimer.c" line="257" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__lptimer_1gaa07d09cfeb275d1343a335f6b4caec9c" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void cyhal_lptimer_enable_event</definition>
        <argsstring>(cyhal_lptimer_t *obj, cyhal_lptimer_event_t event, uint8_t intr_priority, bool enable)</argsstring>
        <name>cyhal_lptimer_enable_event</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__lptimer__t">cyhal_lptimer_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__group__hal__lptimer_1ga8a2db5e37e9e36afd382844cf909278f">cyhal_lptimer_event_t</ref></type>
          <declname>event</declname>
        </param>
        <param>
          <type>uint8_t</type>
          <declname>intr_priority</declname>
        </param>
        <param>
          <type>bool</type>
          <declname>enable</declname>
        </param>
        <briefdescription>
<para>Configure and Enable/Disable the LPTimer events. </para>        </briefdescription>
        <detaileddescription>
<para>When an enabled event occurs, the function specified by <ref kindref="member" refid="group__group__hal__lptimer_1gac670fa5380ffd41e548dac6975500b3d">cyhal_lptimer_register_callback</ref> will be called.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The LPTimer object </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">event</parametername>
</parameternamelist>
<parameterdescription>
<para>The LPTimer event type </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">intr_priority</parametername>
</parameternamelist>
<parameterdescription>
<para>The priority for NVIC interrupt events </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">enable</parametername>
</parameternamelist>
<parameterdescription>
<para>True to turn on event, False to turn off </para></parameterdescription>
</parameteritem>
</parameterlist>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="276" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_lptimer.c" bodystart="267" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_lptimer.c" line="267" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__lptimer_1ga6c86e106c2cc0e5ce0cc4168924a7d41" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void cyhal_lptimer_irq_trigger</definition>
        <argsstring>(cyhal_lptimer_t *obj)</argsstring>
        <name>cyhal_lptimer_irq_trigger</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__lptimer__t">cyhal_lptimer_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <briefdescription>
<para>Manually trigger the LPTimer interrupt. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The LPTimer object </para></parameterdescription>
</parameteritem>
</parameterlist>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="283" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_lptimer.c" bodystart="278" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_lptimer.c" line="278" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__lptimer_1ga35efd806c6a7e0a3c80ef41b0f1e989d" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void cyhal_lptimer_get_info</definition>
        <argsstring>(cyhal_lptimer_t *obj, cyhal_lptimer_info_t *info)</argsstring>
        <name>cyhal_lptimer_get_info</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__lptimer__t">cyhal_lptimer_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type><ref kindref="compound" refid="structcyhal__lptimer__info__t">cyhal_lptimer_info_t</ref> *</type>
          <declname>info</declname>
        </param>
        <briefdescription>
<para>Get information about the LPTimer. </para>        </briefdescription>
        <detaileddescription>
<para>Provides information such as operating frequency, etc.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The LPTimer object. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="out">info</parametername>
</parameternamelist>
<parameterdescription>
<para>Information about the LPtimer. </para></parameterdescription>
</parameteritem>
</parameterlist>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="293" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_lptimer.c" bodystart="285" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_lptimer.c" line="285" />
      </memberdef>
      </sectiondef>
    <briefdescription>
<para>Provides a high level interface for interacting with the Cypress Low-Power Timer. </para>    </briefdescription>
    <detaileddescription>
<para>This interface abstracts out the chip specific details. If any chip specific functionality is necessary, or performance is critical the low level functions can be used directly.</para><para><simplesect kind="copyright"><para>Copyright 2018-2020 Cypress Semiconductor Corporation SPDX-License-Identifier: Apache-2.0</para></simplesect>
Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with the License. You may obtain a copy of the License at <verbatim>http://www.apache.org/licenses/LICENSE-2.0
</verbatim></para><para>Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License. </para>    </detaileddescription>
    <programlisting>
<codeline lineno="1"><highlight class="comment">/***************************************************************************/</highlight></codeline>
<codeline lineno="36"><highlight class="preprocessor">#include<sp />"cmsis_compiler.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="37"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cy_mcwdt.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="38"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cy_syslib.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="39"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cy_sysint.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="40"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cyhal_lptimer.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="41"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cyhal_hwmgr.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="42"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cyhal_system_impl.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="43"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cyhal_utils.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="44"><highlight class="normal" /></codeline>
<codeline lineno="45"><highlight class="normal" /><highlight class="preprocessor">#ifdef<sp />CY_IP_MXS40SRSS_MCWDT_INSTANCES</highlight><highlight class="normal" /></codeline>
<codeline lineno="46"><highlight class="normal" /></codeline>
<codeline lineno="47"><highlight class="normal" /><highlight class="preprocessor">#if<sp />defined(__cplusplus)</highlight><highlight class="normal" /></codeline>
<codeline lineno="48"><highlight class="normal" /><highlight class="keyword">extern</highlight><highlight class="normal"><sp /></highlight><highlight class="stringliteral">"C"</highlight><highlight class="normal"><sp />{</highlight></codeline>
<codeline lineno="49"><highlight class="normal" /><highlight class="preprocessor">#endif</highlight><highlight class="normal" /></codeline>
<codeline lineno="50"><highlight class="normal" /></codeline>
<codeline lineno="51"><highlight class="normal" /><highlight class="keyword">static</highlight><highlight class="normal"><sp />MCWDT_STRUCT_Type<sp />*<sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp />_CYHAL_LPTIMER_BASE_ADDRESSES[]<sp />=<sp />{</highlight></codeline>
<codeline lineno="52"><highlight class="normal" /><highlight class="preprocessor">#if<sp />CY_IP_MXS40SRSS_MCWDT_INSTANCES<sp />&gt;=<sp />1</highlight><highlight class="normal" /></codeline>
<codeline lineno="53"><highlight class="normal"><sp /><sp /><sp /><sp />MCWDT_STRUCT0,</highlight></codeline>
<codeline lineno="54"><highlight class="normal" /><highlight class="preprocessor">#endif</highlight><highlight class="normal" /></codeline>
<codeline lineno="55"><highlight class="normal" /><highlight class="preprocessor">#if<sp />CY_IP_MXS40SRSS_MCWDT_INSTANCES<sp />&gt;=<sp />2</highlight><highlight class="normal" /></codeline>
<codeline lineno="56"><highlight class="normal"><sp /><sp /><sp /><sp />MCWDT_STRUCT1,</highlight></codeline>
<codeline lineno="57"><highlight class="normal" /><highlight class="preprocessor">#endif</highlight><highlight class="normal" /></codeline>
<codeline lineno="58"><highlight class="normal" /><highlight class="preprocessor">#if<sp />CY_IP_MXS40SRSS_MCWDT_INSTANCES<sp />&gt;=<sp />3</highlight><highlight class="normal" /></codeline>
<codeline lineno="59"><highlight class="normal" /><highlight class="preprocessor">#error<sp />"CY_IP_MXS40SRSS_MCWDT_INSTANCES<sp />&gt;<sp />2<sp />not<sp />supported"</highlight><highlight class="normal" /></codeline>
<codeline lineno="60"><highlight class="normal" /><highlight class="preprocessor">#endif</highlight><highlight class="normal" /></codeline>
<codeline lineno="61"><highlight class="normal">};</highlight></codeline>
<codeline lineno="62"><highlight class="normal" /></codeline>
<codeline lineno="63"><highlight class="normal" /><highlight class="preprocessor">#define<sp />_CYHAL_LPTIMER_MCWDT_CTRL<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(CY_MCWDT_CTR0<sp />|<sp />CY_MCWDT_CTR1<sp />|<sp />CY_MCWDT_CTR2)</highlight><highlight class="normal" /></codeline>
<codeline lineno="64"><highlight class="normal" /></codeline>
<codeline lineno="65"><highlight class="normal" /><highlight class="preprocessor">#define<sp />_CYHAL_LPTIMER_MIN_DELAY<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(3U)<sp /></highlight><highlight class="comment">/*<sp />minimum<sp />amount<sp />of<sp />lfclk<sp />cycles<sp />of<sp />that<sp />LPTIMER<sp />can<sp />delay<sp />for.<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline lineno="66"><highlight class="normal" /><highlight class="preprocessor">#define<sp />_CYHAL_LPTIMER_MAX_DELAY_TICKS<sp /><sp /><sp /><sp />(0xfff0ffffUL)<sp /></highlight><highlight class="comment">/*<sp />~36hours,<sp />Not<sp />set<sp />to<sp />0xffffffff<sp />to<sp />avoid<sp />C0<sp />and<sp />C1<sp />both<sp />overflowing<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline lineno="67"><highlight class="normal" /><highlight class="preprocessor">#define<sp />_CYHAL_LPTIMER_MAX_COUNTER_VAL<sp /><sp /><sp /><sp />(0xffffffffUL)<sp /></highlight><highlight class="comment">/*<sp />Maximum<sp />value<sp />of<sp />the<sp />counter<sp />before<sp />it<sp />rolls<sp />over<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline lineno="68"><highlight class="normal" /></codeline>
<codeline lineno="69"><highlight class="normal" /><highlight class="preprocessor">#define<sp />_CYHAL_LPTIMER_DEFAULT_PRIORITY<sp /><sp /><sp />(3U)</highlight><highlight class="normal" /></codeline>
<codeline lineno="70"><highlight class="normal" /></codeline>
<codeline lineno="71"><highlight class="normal" /><highlight class="comment">/*<sp />For<sp />all<sp />PSoC<sp />6<sp />architectures<sp />the<sp />MCWDT<sp />is<sp />driven<sp />by<sp />CLK_LF<sp />that<sp />will<sp />always<sp />run<sp />at<sp />32.768<sp />KHz<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="72"><highlight class="normal" /><highlight class="preprocessor">#define<sp />_CYHAL_LPTIMER_CLK_FREQ_HZ<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(32768U)</highlight><highlight class="normal" /></codeline>
<codeline lineno="73"><highlight class="normal" /></codeline>
<codeline lineno="74"><highlight class="normal" /><highlight class="keyword">static</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp />uint16_t<sp />_CYHAL_LPTIMER_RESET_TIME_US<sp />=<sp />62;</highlight></codeline>
<codeline lineno="75"><highlight class="normal" /><highlight class="keyword">static</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp />uint16_t<sp />_CYHAL_LPTIMER_SETMATCH_NOWAIT_TIME_US<sp />=<sp />0;</highlight></codeline>
<codeline lineno="76"><highlight class="normal" /></codeline>
<codeline lineno="77"><highlight class="normal" /><highlight class="keyword">static</highlight><highlight class="normal"><sp /><ref kindref="compound" refid="structcyhal__lptimer__t">cyhal_lptimer_t</ref><sp />*_cyhal_lptimer_config_structs[CY_IP_MXS40SRSS_MCWDT_INSTANCES];</highlight></codeline>
<codeline lineno="78"><highlight class="normal" /></codeline>
<codeline lineno="79"><highlight class="normal" /><highlight class="keyword">static</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />_cyhal_lptimer_irq_handler(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">)</highlight></codeline>
<codeline lineno="80"><highlight class="normal">{</highlight></codeline>
<codeline lineno="81"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />instance<sp />=<sp />(uint32_t)_CYHAL_UTILS_GET_CURRENT_IRQN()<sp />-<sp />(uint32_t)<sp />srss_interrupt_mcwdt_0_IRQn;</highlight></codeline>
<codeline lineno="82"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcyhal__lptimer__t">cyhal_lptimer_t</ref><sp />*obj<sp />=<sp />_cyhal_lptimer_config_structs[instance];</highlight></codeline>
<codeline lineno="83"><highlight class="normal" /></codeline>
<codeline lineno="84"><highlight class="normal"><sp /><sp /><sp /><sp />Cy_MCWDT_ClearInterrupt(obj-&gt;base,<sp />CY_MCWDT_CTR0<sp />|<sp />CY_MCWDT_CTR1<sp />|<sp />CY_MCWDT_CTR2);</highlight></codeline>
<codeline lineno="85"><highlight class="normal" /></codeline>
<codeline lineno="86"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Clear<sp />interrupt<sp />mask<sp />if<sp />set<sp />only<sp />from<sp />cyhal_lptimer_set_delay()<sp />function<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="87"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(obj-&gt;clear_int_mask)</highlight></codeline>
<codeline lineno="88"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="89"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Cy_MCWDT_SetInterruptMask(obj-&gt;base,<sp />0);</highlight></codeline>
<codeline lineno="90"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="91"><highlight class="normal" /></codeline>
<codeline lineno="92"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(NULL<sp />!=<sp />obj-&gt;callback_data.callback)</highlight></codeline>
<codeline lineno="93"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="94"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__hal__lptimer_1ga09c30c6a9abcbd1a738529102aa9c9b5">cyhal_lptimer_event_callback_t</ref><sp />callback<sp />=<sp />(<ref kindref="member" refid="group__group__hal__lptimer_1ga09c30c6a9abcbd1a738529102aa9c9b5">cyhal_lptimer_event_callback_t</ref>)<sp />obj-&gt;callback_data.callback;</highlight></codeline>
<codeline lineno="95"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(callback)(obj-&gt;callback_data.callback_arg,<sp />CYHAL_LPTIMER_COMPARE_MATCH);</highlight></codeline>
<codeline lineno="96"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="97"><highlight class="normal">}</highlight></codeline>
<codeline lineno="98"><highlight class="normal" /></codeline>
<codeline lineno="99"><highlight class="normal" /><highlight class="keyword">static</highlight><highlight class="normal"><sp />uint32_t<sp />_cyhal_lptimer_set_delay_common(<ref kindref="compound" refid="structcyhal__lptimer__t">cyhal_lptimer_t</ref><sp />*obj,<sp />uint32_t<sp />delay)</highlight></codeline>
<codeline lineno="100"><highlight class="normal">{</highlight></codeline>
<codeline lineno="114"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(delay<sp />&lt;=<sp />_CYHAL_LPTIMER_MIN_DELAY)</highlight></codeline>
<codeline lineno="115"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="116"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />delay<sp />=<sp />_CYHAL_LPTIMER_MIN_DELAY;</highlight></codeline>
<codeline lineno="117"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="118"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(delay<sp />&gt;<sp />_CYHAL_LPTIMER_MAX_DELAY_TICKS)</highlight></codeline>
<codeline lineno="119"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="120"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />delay<sp />=<sp />_CYHAL_LPTIMER_MAX_DELAY_TICKS;</highlight></codeline>
<codeline lineno="121"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="122"><highlight class="normal" /></codeline>
<codeline lineno="123"><highlight class="normal"><sp /><sp /><sp /><sp />uint16_t<sp />c0_increment<sp />=<sp />(uint16_t)delay;</highlight></codeline>
<codeline lineno="124"><highlight class="normal"><sp /><sp /><sp /><sp />uint16_t<sp />c1_increment<sp />=<sp />(uint16_t)(delay<sp />&gt;&gt;<sp />16);</highlight></codeline>
<codeline lineno="125"><highlight class="normal" /></codeline>
<codeline lineno="126"><highlight class="normal"><sp /><sp /><sp /><sp />Cy_MCWDT_ClearInterrupt(obj-&gt;base,<sp />CY_MCWDT_CTR1);</highlight></codeline>
<codeline lineno="127"><highlight class="normal" /></codeline>
<codeline lineno="128"><highlight class="normal"><sp /><sp /><sp /><sp />uint16_t<sp />c0_old_match<sp />=<sp />(uint16_t)Cy_MCWDT_GetMatch(obj-&gt;base,<sp />CY_MCWDT_COUNTER0);</highlight></codeline>
<codeline lineno="129"><highlight class="normal" /></codeline>
<codeline lineno="130"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />critical_section<sp />=<sp /><ref kindref="member" refid="group__group__hal__system_1ga70a306e5108a38aa995c0ab7d0147e43">cyhal_system_critical_section_enter</ref>();</highlight></codeline>
<codeline lineno="131"><highlight class="normal" /></codeline>
<codeline lineno="132"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Cascading<sp />from<sp />C0<sp />match<sp />into<sp />C1<sp />is<sp />queued<sp />and<sp />can<sp />take<sp />1<sp />full<sp />LF<sp />clk<sp />cycle.</highlight></codeline>
<codeline lineno="133"><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />There<sp />are<sp />3<sp />cases:</highlight></codeline>
<codeline lineno="134"><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />Case<sp />1:<sp />if<sp />c0<sp />=<sp />match0<sp />then<sp />the<sp />cascade<sp />into<sp />C1<sp />will<sp />happen<sp />1<sp />cycle<sp />from<sp />now.<sp />The<sp />value<sp />c1_current_ticks<sp />is<sp />1<sp />lower<sp />than<sp />expected.</highlight></codeline>
<codeline lineno="135"><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />Case<sp />2:<sp />if<sp />c0<sp />=<sp />match0<sp />-1<sp />then<sp />cascade<sp />may<sp />or<sp />not<sp />happen<sp />before<sp />new<sp />match<sp />value<sp />would<sp />occur.<sp />Match<sp />occurs<sp />on<sp />rising<sp />clock<sp />edge.</highlight></codeline>
<codeline lineno="136"><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Synching<sp />match<sp />value<sp />occurs<sp />on<sp />falling<sp />edge.<sp />Wait<sp />until<sp />c0<sp />=<sp />match0<sp />to<sp />ensure<sp />cascade<sp />occurs.</highlight></codeline>
<codeline lineno="137"><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />Case<sp />3:<sp />everything<sp />works<sp />as<sp />expected.</highlight></codeline>
<codeline lineno="138"><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="139"><highlight class="normal"><sp /><sp /><sp /><sp />uint16_t<sp />c0_current_ticks<sp />=<sp />(uint16_t)Cy_MCWDT_GetCount(obj-&gt;base,<sp />CY_MCWDT_COUNTER0);</highlight></codeline>
<codeline lineno="140"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//<sp />Wait<sp />until<sp />the<sp />cascade<sp />has<sp />definitively<sp />happened.<sp />It<sp />takes<sp />a<sp />clock<sp />cycle<sp />for<sp />the<sp />cascade<sp />to<sp />happen,<sp />and<sp />potentially<sp />another<sp />a<sp />full<sp /></highlight><highlight class="normal" /></codeline>
<codeline lineno="141"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//<sp />LFCLK<sp />clock<sp />cycle<sp />for<sp />the<sp />cascade<sp />to<sp />propagate<sp />up<sp />to<sp />the<sp />HFCLK-domain<sp />registers<sp />that<sp />the<sp />CPU<sp />reads.</highlight><highlight class="normal" /></codeline>
<codeline lineno="142"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">while</highlight><highlight class="normal"><sp />(((uint16_t)(c0_old_match<sp />-<sp />1))<sp />==<sp />c0_current_ticks<sp />||</highlight></codeline>
<codeline lineno="143"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />c0_old_match<sp /><sp /><sp /><sp /><sp /><sp /><sp />==<sp />c0_current_ticks<sp />||</highlight></codeline>
<codeline lineno="144"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />((uint16_t)(c0_old_match<sp />+<sp />1))<sp />==<sp />c0_current_ticks)</highlight></codeline>
<codeline lineno="145"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="146"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />c0_current_ticks<sp />=<sp />(uint16_t)Cy_MCWDT_GetCount(obj-&gt;base,<sp />CY_MCWDT_COUNTER0);</highlight></codeline>
<codeline lineno="147"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="148"><highlight class="normal" /></codeline>
<codeline lineno="149"><highlight class="normal"><sp /><sp /><sp /><sp />uint16_t<sp />c1_current_ticks<sp />=<sp />(uint16_t)Cy_MCWDT_GetCount(obj-&gt;base,<sp />CY_MCWDT_COUNTER1);</highlight></codeline>
<codeline lineno="150"><highlight class="normal" /></codeline>
<codeline lineno="151"><highlight class="normal"><sp /><sp /><sp /><sp />Cy_MCWDT_SetMatch(obj-&gt;base,<sp />CY_MCWDT_COUNTER0,<sp />c0_current_ticks<sp />+<sp />c0_increment,<sp />_CYHAL_LPTIMER_SETMATCH_NOWAIT_TIME_US);</highlight></codeline>
<codeline lineno="152"><highlight class="normal"><sp /><sp /><sp /><sp />Cy_MCWDT_SetMatch(obj-&gt;base,<sp />CY_MCWDT_COUNTER1,<sp />c1_current_ticks<sp />+<sp />c1_increment,<sp />_CYHAL_LPTIMER_SETMATCH_NOWAIT_TIME_US);</highlight></codeline>
<codeline lineno="153"><highlight class="normal" /></codeline>
<codeline lineno="154"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__hal__system_1ga9fe83f08f46b64c956ec7ed3c335f659">cyhal_system_critical_section_exit</ref>(critical_section);</highlight></codeline>
<codeline lineno="155"><highlight class="normal" /></codeline>
<codeline lineno="156"><highlight class="normal"><sp /><sp /><sp /><sp />Cy_MCWDT_SetInterruptMask(obj-&gt;base,<sp />CY_MCWDT_CTR1);</highlight></codeline>
<codeline lineno="157"><highlight class="normal" /></codeline>
<codeline lineno="158"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref>;</highlight></codeline>
<codeline lineno="159"><highlight class="normal">}</highlight></codeline>
<codeline lineno="160"><highlight class="normal" /></codeline>
<codeline lineno="161"><highlight class="normal"><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref><sp /><ref kindref="member" refid="group__group__hal__lptimer_1gad5438541af765572369ee96588bd4ee5">cyhal_lptimer_init</ref>(<ref kindref="compound" refid="structcyhal__lptimer__t">cyhal_lptimer_t</ref><sp />*obj)</highlight></codeline>
<codeline lineno="162"><highlight class="normal">{</highlight></codeline>
<codeline lineno="163"><highlight class="normal"><sp /><sp /><sp /><sp />CY_ASSERT(NULL<sp />!=<sp />obj);</highlight></codeline>
<codeline lineno="164"><highlight class="normal" /></codeline>
<codeline lineno="165"><highlight class="normal"><sp /><sp /><sp /><sp />obj-&gt;resource.<ref kindref="member" refid="structcyhal__resource__inst__t_1ad111187a65d182386ea96858369b83d4">type</ref><sp />=<sp /><ref kindref="member" refid="group__group__hal__impl__hw__types_1gga63b023ea7b5e73db59ddc0423c77975baf4c05e33bb994cc6a1d94bd301dcc988">CYHAL_RSC_INVALID</ref>;</highlight></codeline>
<codeline lineno="166"><highlight class="normal"><sp /><sp /><sp /><sp />obj-&gt;clear_int_mask<sp />=<sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal">;</highlight></codeline>
<codeline lineno="167"><highlight class="normal" /></codeline>
<codeline lineno="168"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref><sp />rslt<sp />=<sp /><ref kindref="member" refid="group__group__hal__hwmgr_1ga16c02006114bccbf64acbdfd5f2066c2">cyhal_hwmgr_allocate</ref>(<ref kindref="member" refid="group__group__hal__impl__hw__types_1gga63b023ea7b5e73db59ddc0423c77975ba6408a108cf029e1e7b69c98ce86320e7">CYHAL_RSC_LPTIMER</ref>,<sp />&amp;(obj-&gt;resource));</highlight></codeline>
<codeline lineno="169"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref><sp />==<sp />rslt)</highlight></codeline>
<codeline lineno="170"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="171"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />obj-&gt;base<sp />=<sp />_CYHAL_LPTIMER_BASE_ADDRESSES[obj-&gt;resource.<ref kindref="member" refid="structcyhal__resource__inst__t_1a91895766b5f5efe1dfffac2d7537e73a">block_num</ref>];</highlight></codeline>
<codeline lineno="172"><highlight class="normal" /></codeline>
<codeline lineno="173"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp />cy_stc_mcwdt_config_t<sp />cfg<sp />=<sp />{</highlight></codeline>
<codeline lineno="174"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.c0Match<sp />=<sp />0xFFFF,</highlight></codeline>
<codeline lineno="175"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.c1Match<sp />=<sp />0xFFFF,</highlight></codeline>
<codeline lineno="176"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.c0Mode<sp />=<sp />CY_MCWDT_MODE_INT,</highlight></codeline>
<codeline lineno="177"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.c1Mode<sp />=<sp />CY_MCWDT_MODE_INT,</highlight></codeline>
<codeline lineno="178"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.c2Mode<sp />=<sp />CY_MCWDT_MODE_NONE,</highlight></codeline>
<codeline lineno="179"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.c2ToggleBit<sp />=<sp />0,</highlight></codeline>
<codeline lineno="180"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.c0ClearOnMatch<sp />=<sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal">,</highlight></codeline>
<codeline lineno="181"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.c1ClearOnMatch<sp />=<sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal">,</highlight></codeline>
<codeline lineno="182"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.c0c1Cascade<sp />=<sp /></highlight><highlight class="keyword">true</highlight><highlight class="normal">,</highlight></codeline>
<codeline lineno="183"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.c1c2Cascade<sp />=<sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal" /></codeline>
<codeline lineno="184"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />};</highlight></codeline>
<codeline lineno="185"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />rslt<sp />=<sp />(<ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref>)<sp />Cy_MCWDT_Init(obj-&gt;base,<sp />&amp;cfg);</highlight></codeline>
<codeline lineno="186"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="187"><highlight class="normal" /></codeline>
<codeline lineno="188"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref><sp />==<sp />rslt)</highlight></codeline>
<codeline lineno="189"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="190"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />obj-&gt;callback_data.callback<sp />=<sp />NULL;</highlight></codeline>
<codeline lineno="191"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />obj-&gt;callback_data.callback_arg<sp />=<sp />NULL;</highlight></codeline>
<codeline lineno="192"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />_cyhal_lptimer_config_structs[obj-&gt;resource.<ref kindref="member" refid="structcyhal__resource__inst__t_1a91895766b5f5efe1dfffac2d7537e73a">block_num</ref>]<sp />=<sp />obj;</highlight></codeline>
<codeline lineno="193"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="194"><highlight class="normal" /></codeline>
<codeline lineno="195"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref><sp />==<sp />rslt)</highlight></codeline>
<codeline lineno="196"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="197"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />IRQn_Type<sp />irqn<sp />=<sp />(IRQn_Type)<sp />(srss_interrupt_mcwdt_0_IRQn<sp />+<sp />obj-&gt;resource.<ref kindref="member" refid="structcyhal__resource__inst__t_1a91895766b5f5efe1dfffac2d7537e73a">block_num</ref>);</highlight></codeline>
<codeline lineno="198"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />cy_stc_sysint_t<sp />irqCfg<sp />=<sp />{<sp />irqn,<sp />_CYHAL_LPTIMER_DEFAULT_PRIORITY<sp />};</highlight></codeline>
<codeline lineno="199"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />rslt<sp />=<sp />(<ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref>)<sp />Cy_SysInt_Init(&amp;irqCfg,<sp />&amp;_cyhal_lptimer_irq_handler);</highlight></codeline>
<codeline lineno="200"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref><sp />==<sp />rslt)</highlight></codeline>
<codeline lineno="201"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="202"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />NVIC_EnableIRQ(irqn);</highlight></codeline>
<codeline lineno="203"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Cy_MCWDT_Enable(obj-&gt;base,<sp />_CYHAL_LPTIMER_MCWDT_CTRL,<sp />_CYHAL_LPTIMER_RESET_TIME_US);</highlight></codeline>
<codeline lineno="204"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="205"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="206"><highlight class="normal" /></codeline>
<codeline lineno="207"><highlight class="normal" /></codeline>
<codeline lineno="208"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref><sp />!=<sp />rslt)</highlight></codeline>
<codeline lineno="209"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="210"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__hal__lptimer_1ga0cbaebaddaa47faf71a69d46c65f7917">cyhal_lptimer_free</ref>(obj);</highlight></codeline>
<codeline lineno="211"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="212"><highlight class="normal" /></codeline>
<codeline lineno="213"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />rslt;</highlight></codeline>
<codeline lineno="214"><highlight class="normal">}</highlight></codeline>
<codeline lineno="215"><highlight class="normal" /></codeline>
<codeline lineno="216"><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__hal__lptimer_1ga0cbaebaddaa47faf71a69d46c65f7917">cyhal_lptimer_free</ref>(<ref kindref="compound" refid="structcyhal__lptimer__t">cyhal_lptimer_t</ref><sp />*obj)</highlight></codeline>
<codeline lineno="217"><highlight class="normal">{</highlight></codeline>
<codeline lineno="218"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__hal__impl__hw__types_1gga63b023ea7b5e73db59ddc0423c77975baf4c05e33bb994cc6a1d94bd301dcc988">CYHAL_RSC_INVALID</ref><sp />!=<sp />obj-&gt;resource.<ref kindref="member" refid="structcyhal__resource__inst__t_1ad111187a65d182386ea96858369b83d4">type</ref>)</highlight></codeline>
<codeline lineno="219"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="220"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />IRQn_Type<sp />irqn<sp />=<sp />(IRQn_Type)(srss_interrupt_mcwdt_0_IRQn<sp />+<sp />obj-&gt;resource.<ref kindref="member" refid="structcyhal__resource__inst__t_1a91895766b5f5efe1dfffac2d7537e73a">block_num</ref>);</highlight></codeline>
<codeline lineno="221"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />NVIC_DisableIRQ(irqn);</highlight></codeline>
<codeline lineno="222"><highlight class="normal" /></codeline>
<codeline lineno="223"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__hal__hwmgr_1gaa1979bd596d90251c7b861a7e94b884f">cyhal_hwmgr_free</ref>(&amp;(obj-&gt;resource));</highlight></codeline>
<codeline lineno="224"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />obj-&gt;resource.<ref kindref="member" refid="structcyhal__resource__inst__t_1ad111187a65d182386ea96858369b83d4">type</ref><sp />=<sp /><ref kindref="member" refid="group__group__hal__impl__hw__types_1gga63b023ea7b5e73db59ddc0423c77975baf4c05e33bb994cc6a1d94bd301dcc988">CYHAL_RSC_INVALID</ref>;</highlight></codeline>
<codeline lineno="225"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="226"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(NULL<sp />!=<sp />obj-&gt;base)</highlight></codeline>
<codeline lineno="227"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="228"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Cy_MCWDT_Disable(obj-&gt;base,<sp />_CYHAL_LPTIMER_MCWDT_CTRL,<sp />_CYHAL_LPTIMER_RESET_TIME_US);</highlight></codeline>
<codeline lineno="229"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Cy_MCWDT_DeInit(obj-&gt;base);</highlight></codeline>
<codeline lineno="230"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />obj-&gt;base<sp />=<sp />NULL;</highlight></codeline>
<codeline lineno="231"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="232"><highlight class="normal">}</highlight></codeline>
<codeline lineno="233"><highlight class="normal" /></codeline>
<codeline lineno="234"><highlight class="normal"><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref><sp /><ref kindref="member" refid="group__group__hal__lptimer_1ga5ed361c85190707574565009eb325473">cyhal_lptimer_reload</ref>(<ref kindref="compound" refid="structcyhal__lptimer__t">cyhal_lptimer_t</ref><sp />*obj)</highlight></codeline>
<codeline lineno="235"><highlight class="normal">{</highlight></codeline>
<codeline lineno="236"><highlight class="normal"><sp /><sp /><sp /><sp />Cy_MCWDT_ResetCounters(obj-&gt;base,<sp />(CY_MCWDT_CTR0<sp />|<sp />CY_MCWDT_CTR1<sp />|<sp />CY_MCWDT_CTR2),<sp />2<sp />*<sp />_CYHAL_LPTIMER_RESET_TIME_US);</highlight></codeline>
<codeline lineno="237"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref>;</highlight></codeline>
<codeline lineno="238"><highlight class="normal">}</highlight></codeline>
<codeline lineno="239"><highlight class="normal" /></codeline>
<codeline lineno="240"><highlight class="normal"><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref><sp /><ref kindref="member" refid="group__group__hal__lptimer_1ga39d049f6f4bdd0bcd4e0be2ab48d3394">cyhal_lptimer_set_match</ref>(<ref kindref="compound" refid="structcyhal__lptimer__t">cyhal_lptimer_t</ref><sp />*obj,<sp />uint32_t<sp />ticks)</highlight></codeline>
<codeline lineno="241"><highlight class="normal">{</highlight></codeline>
<codeline lineno="242"><highlight class="normal"><sp /><sp /><sp /><sp />obj-&gt;clear_int_mask<sp />=<sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal">;</highlight></codeline>
<codeline lineno="243"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />_cyhal_lptimer_set_delay_common(obj,<sp />ticks<sp />-<sp /><ref kindref="member" refid="group__group__hal__lptimer_1gae759c60b5865a26599353e436518b1d3">cyhal_lptimer_read</ref>(obj));</highlight></codeline>
<codeline lineno="244"><highlight class="normal">}</highlight></codeline>
<codeline lineno="245"><highlight class="normal" /></codeline>
<codeline lineno="246"><highlight class="normal"><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref><sp /><ref kindref="member" refid="group__group__hal__lptimer_1gae91cdc8b63ef191f5a2013df3aaa5d78">cyhal_lptimer_set_delay</ref>(<ref kindref="compound" refid="structcyhal__lptimer__t">cyhal_lptimer_t</ref><sp />*obj,<sp />uint32_t<sp />delay)</highlight></codeline>
<codeline lineno="247"><highlight class="normal">{</highlight></codeline>
<codeline lineno="248"><highlight class="normal"><sp /><sp /><sp /><sp />obj-&gt;clear_int_mask<sp />=<sp /></highlight><highlight class="keyword">true</highlight><highlight class="normal">;</highlight></codeline>
<codeline lineno="249"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />_cyhal_lptimer_set_delay_common(obj,<sp />delay);</highlight></codeline>
<codeline lineno="250"><highlight class="normal">}</highlight></codeline>
<codeline lineno="251"><highlight class="normal" /></codeline>
<codeline lineno="252"><highlight class="normal">uint32_t<sp /><ref kindref="member" refid="group__group__hal__lptimer_1gae759c60b5865a26599353e436518b1d3">cyhal_lptimer_read</ref>(</highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /><ref kindref="compound" refid="structcyhal__lptimer__t">cyhal_lptimer_t</ref><sp />*obj)</highlight></codeline>
<codeline lineno="253"><highlight class="normal">{</highlight></codeline>
<codeline lineno="254"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />Cy_MCWDT_GetCount(obj-&gt;base,<sp />CY_MCWDT_COUNTER2);</highlight></codeline>
<codeline lineno="255"><highlight class="normal">}</highlight></codeline>
<codeline lineno="256"><highlight class="normal" /></codeline>
<codeline lineno="257"><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__hal__lptimer_1gac670fa5380ffd41e548dac6975500b3d">cyhal_lptimer_register_callback</ref>(<ref kindref="compound" refid="structcyhal__lptimer__t">cyhal_lptimer_t</ref><sp />*obj,<sp /><ref kindref="member" refid="group__group__hal__lptimer_1ga09c30c6a9abcbd1a738529102aa9c9b5">cyhal_lptimer_event_callback_t</ref><sp />callback,<sp /></highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />*callback_arg)</highlight></codeline>
<codeline lineno="258"><highlight class="normal">{</highlight></codeline>
<codeline lineno="259"><highlight class="normal"><sp /><sp /><sp /><sp />CY_ASSERT(<ref kindref="member" refid="group__group__hal__impl__hw__types_1gga63b023ea7b5e73db59ddc0423c77975baf4c05e33bb994cc6a1d94bd301dcc988">CYHAL_RSC_INVALID</ref><sp />!=<sp />obj-&gt;resource.<ref kindref="member" refid="structcyhal__resource__inst__t_1a91895766b5f5efe1dfffac2d7537e73a">block_num</ref>);</highlight></codeline>
<codeline lineno="260"><highlight class="normal" /></codeline>
<codeline lineno="261"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />savedIntrStatus<sp />=<sp /><ref kindref="member" refid="group__group__hal__system_1ga70a306e5108a38aa995c0ab7d0147e43">cyhal_system_critical_section_enter</ref>();</highlight></codeline>
<codeline lineno="262"><highlight class="normal"><sp /><sp /><sp /><sp />obj-&gt;callback_data.callback<sp />=<sp />(cy_israddress)<sp />callback;</highlight></codeline>
<codeline lineno="263"><highlight class="normal"><sp /><sp /><sp /><sp />obj-&gt;callback_data.callback_arg<sp />=<sp />callback_arg;</highlight></codeline>
<codeline lineno="264"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__hal__system_1ga9fe83f08f46b64c956ec7ed3c335f659">cyhal_system_critical_section_exit</ref>(savedIntrStatus);</highlight></codeline>
<codeline lineno="265"><highlight class="normal">}</highlight></codeline>
<codeline lineno="266"><highlight class="normal" /></codeline>
<codeline lineno="267"><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__hal__lptimer_1gaa07d09cfeb275d1343a335f6b4caec9c">cyhal_lptimer_enable_event</ref>(<ref kindref="compound" refid="structcyhal__lptimer__t">cyhal_lptimer_t</ref><sp />*obj,<sp /><ref kindref="member" refid="group__group__hal__lptimer_1ga8a2db5e37e9e36afd382844cf909278f">cyhal_lptimer_event_t</ref><sp />event,<sp />uint8_t<sp />intr_priority,<sp /></highlight><highlight class="keywordtype">bool</highlight><highlight class="normal"><sp />enable)</highlight></codeline>
<codeline lineno="268"><highlight class="normal">{</highlight></codeline>
<codeline lineno="269"><highlight class="normal"><sp /><sp /><sp /><sp />CY_UNUSED_PARAMETER(event);</highlight></codeline>
<codeline lineno="270"><highlight class="normal"><sp /><sp /><sp /><sp />CY_ASSERT(event<sp />==<sp />CYHAL_LPTIMER_COMPARE_MATCH);</highlight></codeline>
<codeline lineno="271"><highlight class="normal"><sp /><sp /><sp /><sp />Cy_MCWDT_ClearInterrupt(obj-&gt;base,<sp />CY_MCWDT_CTR1);</highlight></codeline>
<codeline lineno="272"><highlight class="normal"><sp /><sp /><sp /><sp />Cy_MCWDT_SetInterruptMask(obj-&gt;base,<sp />enable<sp />?<sp />CY_MCWDT_CTR1<sp />:<sp />0);</highlight></codeline>
<codeline lineno="273"><highlight class="normal" /></codeline>
<codeline lineno="274"><highlight class="normal"><sp /><sp /><sp /><sp />IRQn_Type<sp />irqn<sp />=<sp />(IRQn_Type)(srss_interrupt_mcwdt_0_IRQn<sp />+<sp />obj-&gt;resource.<ref kindref="member" refid="structcyhal__resource__inst__t_1a91895766b5f5efe1dfffac2d7537e73a">block_num</ref>);</highlight></codeline>
<codeline lineno="275"><highlight class="normal"><sp /><sp /><sp /><sp />NVIC_SetPriority(irqn,<sp />intr_priority);</highlight></codeline>
<codeline lineno="276"><highlight class="normal">}</highlight></codeline>
<codeline lineno="277"><highlight class="normal" /></codeline>
<codeline lineno="278"><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__hal__lptimer_1ga6c86e106c2cc0e5ce0cc4168924a7d41">cyhal_lptimer_irq_trigger</ref>(<ref kindref="compound" refid="structcyhal__lptimer__t">cyhal_lptimer_t</ref><sp />*obj)</highlight></codeline>
<codeline lineno="279"><highlight class="normal">{</highlight></codeline>
<codeline lineno="280"><highlight class="normal"><sp /><sp /><sp /><sp />CY_ASSERT(<ref kindref="member" refid="group__group__hal__impl__hw__types_1gga63b023ea7b5e73db59ddc0423c77975baf4c05e33bb994cc6a1d94bd301dcc988">CYHAL_RSC_INVALID</ref><sp />!=<sp />obj-&gt;resource.<ref kindref="member" refid="structcyhal__resource__inst__t_1a91895766b5f5efe1dfffac2d7537e73a">block_num</ref>);</highlight></codeline>
<codeline lineno="281"><highlight class="normal"><sp /><sp /><sp /><sp />IRQn_Type<sp />irqn<sp />=<sp />(IRQn_Type)(srss_interrupt_mcwdt_0_IRQn<sp />+<sp />obj-&gt;resource.<ref kindref="member" refid="structcyhal__resource__inst__t_1a91895766b5f5efe1dfffac2d7537e73a">block_num</ref>);</highlight></codeline>
<codeline lineno="282"><highlight class="normal"><sp /><sp /><sp /><sp />NVIC_SetPendingIRQ(irqn);</highlight></codeline>
<codeline lineno="283"><highlight class="normal">}</highlight></codeline>
<codeline lineno="284"><highlight class="normal" /></codeline>
<codeline lineno="285"><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__hal__lptimer_1ga35efd806c6a7e0a3c80ef41b0f1e989d">cyhal_lptimer_get_info</ref>(<ref kindref="compound" refid="structcyhal__lptimer__t">cyhal_lptimer_t</ref><sp />*obj,<sp /><ref kindref="compound" refid="structcyhal__lptimer__info__t">cyhal_lptimer_info_t</ref><sp />*info)</highlight></codeline>
<codeline lineno="286"><highlight class="normal">{</highlight></codeline>
<codeline lineno="287"><highlight class="normal"><sp /><sp /><sp /><sp />CY_UNUSED_PARAMETER(obj);</highlight></codeline>
<codeline lineno="288"><highlight class="normal"><sp /><sp /><sp /><sp />CY_ASSERT(info<sp />!=<sp />NULL);</highlight></codeline>
<codeline lineno="289"><highlight class="normal" /></codeline>
<codeline lineno="290"><highlight class="normal"><sp /><sp /><sp /><sp />info-&gt;<ref kindref="member" refid="structcyhal__lptimer__info__t_1a4e13c1d5a49242cc9c88c1ae28eaa6d1">frequency_hz</ref><sp />=<sp />_CYHAL_LPTIMER_CLK_FREQ_HZ;</highlight></codeline>
<codeline lineno="291"><highlight class="normal"><sp /><sp /><sp /><sp />info-&gt;<ref kindref="member" refid="structcyhal__lptimer__info__t_1ad0043d671bf3be7655d7701d6fbedcb8">min_set_delay</ref><sp />=<sp />_CYHAL_LPTIMER_MIN_DELAY;</highlight></codeline>
<codeline lineno="292"><highlight class="normal"><sp /><sp /><sp /><sp />info-&gt;<ref kindref="member" refid="structcyhal__lptimer__info__t_1ad1c80953a10b9fb43df70da51da519dc">max_counter_value</ref><sp />=<sp />_CYHAL_LPTIMER_MAX_COUNTER_VAL;</highlight></codeline>
<codeline lineno="293"><highlight class="normal">}</highlight></codeline>
<codeline lineno="294"><highlight class="normal" /></codeline>
<codeline lineno="295"><highlight class="normal" /><highlight class="preprocessor">#if<sp />defined(__cplusplus)</highlight><highlight class="normal" /></codeline>
<codeline lineno="296"><highlight class="normal">}</highlight></codeline>
<codeline lineno="297"><highlight class="normal" /><highlight class="preprocessor">#endif</highlight><highlight class="normal" /></codeline>
<codeline lineno="298"><highlight class="normal" /></codeline>
<codeline lineno="299"><highlight class="normal" /><highlight class="preprocessor">#endif<sp /></highlight><highlight class="comment">/*<sp />CY_IP_MXS40SRSS_MCWDT_INSTANCES<sp />*/</highlight><highlight class="preprocessor" /></codeline>
    </programlisting>
    <location file="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_lptimer.c" />
  </compounddef>
</doxygen>